<Cabbage> bounds(0, 0, 0, 0)
form caption("John Olivera - FM Simple") size(855, 420), colour(100, 0, 0), pluginid("def1")
;----------------------------------------------------------------------
;;C M I
groupbox bounds(252, 8, 100, 120) identchannel("FM")
{
nslider bounds(5, 5, 90, 35)  range(1, 10, 1, 1, 0.001) velocity(50) identchannel("FMM") channel("FMM") text("M") value(1)
nslider bounds(5, 43, 90, 35) range(1, 10, 1, 1, 0.001) velocity(50) identchannel("FMC") channel("FMC") text("C") value(1)
nslider bounds(5, 80, 90, 35) range(1, 10, 1, 1, 0.001) velocity(50) identchannel("FMI") channel("FMI") text("I") value(1)
}
;-----------------------------------------------------------------
;;Tuner
groupbox bounds(10, 8, 235, 120) identchannel("tuners") text("Afinadores")
{
rslider bounds(0, 20, 90, 90)   range(-1, 1, 0, 1, 0.001) channel("fine")   text("Fine") valuetextbox(1) 
rslider bounds(75, 20, 90, 90)  range(-12, 12, 0, 1, 1)   channel("coarse") increment(1) text("Coarse") valuetextbox(1) 
rslider bounds(150, 20, 90, 90) range(-3, 3, 0, 1, 1)     channel("range")  increment(1) text("Range")  valuetextbox(1) 
}
;-----------------------------------------------------------------
;;Filter
groupbox bounds(361, 8, 200, 120) identchannel("filter") text("Filtros")
{
rslider bounds(10, 20, 90, 90)  range(20, 20000, 20000, 1, 1) channel("cutoff") value(20000)       increment(1) text("Cutoff") valuetextbox(1)
rslider bounds(100, 20, 90, 90) range(0, 1, 0, 1, 0.001)      channel("res")    text("Resonancia") valuetextbox(1)
}
;-----------------------------------------------------------------
;;Pan
groupbox bounds(574, 8, 270, 120) identchannel("Main") text("Main")
{
rslider  bounds(40, 20, 90, 90)  channel("Vol") range(0, 1, .8, 1, 0.001) value(0.8) text("Vol") valuetextbox(1)
rslider  bounds(140, 20, 90, 90) channel("Pan") range(0, 1, .5, 1, 0.001) value(0.5) text("Pan") valuetextbox(1)
}
;-----------------------------------------------------------------
;;LFO to PitchEg
groupbox bounds(10, 140, 270, 160) identchannel("LFOPitchEg") text("PitchEG/LFO")
{
button   bounds(20, 28, 60, 25)  channel("LFOSW2")           text("Off", "On") 
combobox bounds(100, 28, 60, 25) channel("LFOWF2")           text("Sine", "Triangle", "Square Bipolar", "Square Unipolar", "Saw", "Saw Down")
rslider  bounds(5, 55, 90, 90)   range(0, 20, 1.5, 1, 0.001) channel("LFO_R2") value(1.5)         text("Rate")   valuetextbox(1)
rslider  bounds(85, 55, 90, 90)  range(0, 1, 0.3, 1, 0.001)  channel("LFO_A2") value(0.3)         text("Amount") valuetextbox(1)
nslider  bounds(180, 90, 65, 35) range(1, 4, 1, 1, 0.0001)   velocity(50)      channel("LFOMin2") text("Minimo") value(1)
nslider  bounds(180, 40, 65, 35) range(1, 4, 2, 1, 0.0001)   velocity(50)      channel("LFOMax2") text("Maximo") valuetextbox(1) value(2)
}
;;Pitch EG
groupbox bounds(10, 140, 270, 160) identchannel("PitchEG") text("PitchEG/LFO")
{
button   bounds(20, 30, 60, 25)  text("Off", "On")                 channel("PitchButton")     
rslider  bounds(0, 58, 90, 90)   range(0.001, 4, 0.0001, 1, 0.01)  channel("A1") increment(0.001) valuetextbox(1) text("A") value(0)
rslider  bounds(63, 58, 90, 90)  range(0.001, 4, 0.0001, 1, 0.01)  channel("D1") increment(0.001) valuetextbox(1) text("D") value(0)
rslider  bounds(123, 58, 90, 90) range(0, 1, 0.8, 1, 0.01)         channel("S1") increment(0.001) valuetextbox(1) text("S") value(0)
rslider  bounds(183, 58, 90, 90) range(0.001, 4, 0.0001, 1, 0.01)  channel("R1") increment(0.001) valuetextbox(1) text("R") value(0)
nslider  bounds(100, 23, 65, 35) range(1, 4, 0, 1, 0.0001)         velocity(50)  channel("kMin")  text("Minimo")  value(1)
nslider  bounds(180, 23, 65, 35) range(1, 4, 1, 1, 0.0001)         velocity(50)  channel("kMax")  text("Maximo")  valuetextbox(1) value(2)
} 
;;Pitch EG/LFO
button bounds(220, 140, 60, 20) text("PEG", "LFO") channel("SW3")
;----------------------------------------------------------------------
;;LFO to AMP
groupbox bounds(574, 140, 270, 160) identchannel("LFOAEG") text("AEG/LFO")
{
combobox bounds(150, 28, 60, 25) channel("LFOWF1") text("Sine", "Triangle", "Square Bipolar", "Square Unipolar", "Saw", "Saw Down")
button   bounds(50, 28, 60, 25)  channel("LFOSW1") text("Off", "On") 
rslider  bounds(35, 55, 90, 90)  channel("LFO_R1") range(0, 20, 1.5, 1, 0.001) value(1.5) text("Rate")   valuetextbox(1)
rslider  bounds(135, 55, 90, 90) channel("LFO_A1") range(0, 1, 0.3, 1, 0.001)  value(0.3) text("Amount") valuetextbox(1)
}
;;AEG
groupbox bounds(574, 140, 270, 160) identchannel("AEGLFO") text("AEG/LFO")
{
rslider  bounds(0, 40, 90, 90)   range(0.0001, 6, 0.0001, 1, 0.01)  channel("A2") increment(0.01) valuetextbox(1) text("A") value(0.0001)
rslider  bounds(63, 40, 90, 90)  range(0.0001, 6, 0.0001, 1, 0.01)  channel("D2") increment(0.01) valuetextbox(1) text("D") value(0.0001)
rslider  bounds(123, 40, 90, 90) range(0, 1, 0.8, 1, 0.01)          channel("S2") increment(0.01) valuetextbox(1) text("S") value(0.8)
rslider  bounds(183, 40, 90, 90) range(0.0001, 6, 0.0001, 1, 0.01)  channel("R2") increment(0.01) valuetextbox(1) text("R") value(0.0001)
}
;;boton de LFOA a LFOPitch
button bounds(780, 141, 60, 20) text("AEG", "LFO") channel("SW9")
;----------------------------------------------------------------------
;;LFO to I
groupbox bounds(292, 141, 270, 160) identchannel("LFOI") text("LFO to I")
{
combobox bounds(150, 28, 60, 25) channel("LFOWF3") text("Sine", "Triangle", "Square Bipolar", "Square Unipolar", "Saw", "Saw Down")
button   bounds(50, 28, 60, 25)  channel("LFOSW3") text("Off", "On") 
rslider  bounds(35, 55, 90, 90)  channel("LFO_R3") range(0, 20, 1.5, 1, 0.001) value(1.5) text("Rate")   valuetextbox(1)
rslider  bounds(135, 55, 90, 90) channel("LFO_A3") range(0, 1, 0.3, 1, 0.001)  value(0.3) text("Amount") valuetextbox(1)
}
;;AEG to I
groupbox bounds(292, 141, 270, 160) identchannel("AEGI") text("Index EG")
{
button   bounds(110, 25, 60, 25) channel("IButton")                 text("Off", "On") 
rslider  bounds(0, 53, 90, 90)   range(0.0001, 6, 0.0001, 1, 0.01)  channel("A3") increment(0.01) valuetextbox(1) text("A") value(0.0001)
rslider  bounds(63, 53, 90, 90)  range(0.0001, 6, 0.0001, 1, 0.01)  channel("D3") increment(0.01) valuetextbox(1) text("D") value(0.0001)
rslider  bounds(123, 53, 90, 90) range(0, 1, 1, 1, 0.01)            channel("S3") increment(0.01) valuetextbox(1) text("S") value(0.8000)
rslider  bounds(183, 53, 90, 90) range(0.0001, 6, 0.0001, 1, 0.01)  channel("R3") increment(0.01) valuetextbox(1) text("R") value(0.0001)
}
;;boton de INDEXEG a LFO to INDEX
button bounds(501, 141, 60, 20) text("INDEXEG", "LFO") channel("SW5")
;----------------------------------------------------------------------
keyboard bounds(10, 312, 833, 100)
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

;instrument will be triggered by keyboard widget
        instr 09

;;Afinadores
kfine   chnget "fine"
kcoarse chnget "coarse"
krange  chnget "range"
kfine   pow 2, kfine / 12 
kcoarse pow 2, kcoarse/12
krange  pow 2, krange

;;Filtros
kcutoff chnget "cutoff"
kreson  chnget "res"

;;Pitch EG K2
iA1     chnget "A1"
iD1     chnget "D1"
iS1     chnget "S1"
iR1     chnget "R1"
kMax9   chnget "kMax"
kMin9   chnget "kMin"
ksw4    chnget "PitchButton"
if      ksw4    == 0 then
        k2 = 1
else
        k2    madsr       iA1 , iD1 , iS1 , iR1 
        k2  = kMax9 - ( kMax9 - kMin9 ) * ( 1 - k2 )
endif

;;AEG K3
iA2     chnget "A2"
iD2     chnget "D2"
iS2     chnget "S2"
iR2     chnget "R2"
k3      madsr      iA2 , iD2 , iS2 , iR2

;;LFO to AMP K4
ksw1    chnget  "LFOSW1"
iwf1    chnget  "LFOWF1"
kamnt1  chnget  "LFO_A1"        
krate1  chnget  "LFO_R1"
if      ksw1    == 0 then
        k4  = 1
else
k4      lfo     1, krate1, iwf1-1 
k4             = 1 - (kamnt1 - k4) * .5*kamnt1
endif
;-----------------------------------------------------------------
;;LFO to Pitch K5
ksw2    chnget  "LFOSW2"
iwf2    chnget  "LFOWF2"
kamnt2  chnget  "LFO_A2"        
krate2  chnget  "LFO_R2"
kmin2   chnget  "LFOMin2"    
kmax2   chnget  "LFOMax2"
if      ksw2    == 0 then
        k5  = 1
else
k5      lfo    1, krate2, iwf2-1 
k5             = kmax2 - (kmax2 - kmin2) * (kamnt2 - k5) * .5*kamnt2 
endif
;-----------------------------------------------------------------
;;C M
k6      chnget "FMC"
k7      chnget "FMM"
k8      chnget "FMI"
;-----------------------------------------------------------------
;;EG to Index K10
iA3     chnget "A3"
iD3     chnget "D3"
iS3     chnget "S3"
iR3     chnget "R3"
ksw7    chnget "IButton"
if      ksw7    == 0 then
        k10 = 1
else
        k10   madsr  iA3 , iD3 , iS3 , iR3
endif

;;LFO to Index K9
ksw6    chnget  "LFOSW3"
iwf6    chnget  "LFOWF3"
kamnt6  chnget  "LFO_A3"        
krate6  chnget  "LFO_R3"
if      ksw6    == 0 then
        k9  = 1
else
k9      lfo     1, krate6, iwf6-1 
k9            = 1 - (kamnt6 - k9) * .5*kamnt6
endif
;-----------------------------------------------------------------
;;Pan
kvol   chnget "Vol"
kpan   chnget "Pan"

;;Boton cambio de PEG a LFOPEG
kSW3   chnget  "SW3"
if     (kSW3) == 1 then
       chnset "visible(0)" ,"PitchEG"
else
       chnset "visible(1)" ,"PitchEG"
endif
;-----------------------------------------------------------------        
;;Boton cambio de AEG a LFOAEG 
kSW9    chnget  "SW9"
if      (kSW9) == 1 then
        chnset "visible(0)" ,"AEGLFO"
else
        chnset "visible(1)" ,"AEGLFO"
endif
;-----------------------------------------------------------------       
;;Boton cambio de AEGI a PITCHI
kSW5    chnget  "SW5"
if      (kSW5) == 1 then
        chnset "visible(0)" ,"AEGI"
else
        chnset "visible(1)" ,"AEGI"
endif        
;-----------------------------------------------------------------        
;;FM
a1      foscili  p5*k3*k4, p4*kfine*kcoarse*krange*k2*k5 , k6 , k7 , k8*k9*k10 , 1 
aout    moogvcf2 a1, kcutoff, kreson
        outs     aout*kvol*(1-kpan) , aout*kvol*kpan
        endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
i09 0 3600
f1 0 16384 10 1 ;seno
</CsScore>
</CsoundSynthesizer>
